// Copyright (c) 2022 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "util/flag.hpp"
#include "display/Color.hpp"

#define RENDER_TARGET_CLEAR_FLAG_COLOR FLAG_DEFINE(0)
#define RENDER_TARGET_CLEAR_FLAG_DEPTH FLAG_DEFINE(1)

namespace Dawn {
  class RenderTarget {
    public:
      virtual float_t getWidth() = 0;
      virtual float_t getHeight() = 0;
      virtual void setClearColor(struct Color color) = 0;
      virtual void clear(flag8_t clearFlags) = 0;
      virtual void bind() = 0;
  };
}