// Copyright (c) 2022 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "dawnlibs.hpp"

namespace Dawn {
  class SceneItem;
  class Scene;
  class DawnGame;

  class SceneItemComponent {
    public:
      SceneItem &item;

      SceneItemComponent(SceneItem &item);
      
      virtual void start() = 0;

      Scene & getScene();
      DawnGame & getGame();

      virtual ~SceneItemComponent();
  };
}