// Copyright (c) 2022 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "dawnopengl.hpp"
#include "display/RenderTarget.hpp"

namespace Dawn {
  class RenderManager;

  class BackBufferRenderTarget : public RenderTarget {
    private:
      RenderManager &renderManager;
      float_t width = 1;
      float_t height = 1; 
      struct Color clearColor = COLOR_CORNFLOWER_BLUE;

    public:
      BackBufferRenderTarget(RenderManager &renderManager);

      float_t getWidth() override;
      float_t getHeight() override;

      void setSize(float_t width, float_t height);

      void setClearColor(struct Color color);

      void clear(flag8_t clearFlags) override;
      void bind() override;
  };
}