// Copyright (c) 2022 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "dawnopengl.hpp"
#include "game/DawnGame.hpp"
#include "display/RenderManager.hpp"
#include "display/StandardRenderPipeline.hpp"

using namespace Dawn;

RenderManager::RenderManager(DawnGame &game) :
  IRenderManager(game),
  backBuffer(*this)
{
  this->standardRenderPipeline=std::make_shared<StandardRenderPipeline>(*this);
}

void RenderManager::init() {
  this->standardRenderPipeline->init();
}

RenderTarget & RenderManager::getBackBuffer() {
  return this->backBuffer;
}

RenderPipeline & RenderManager::getRenderPipeline() {
  return *this->standardRenderPipeline;
}

void RenderManager::update() {
  this->getRenderPipeline().render();
}

RenderManager::~RenderManager() {

}