// Copyright (c) 2022 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "display/_RenderManager.hpp"
#include "display/BackBufferRenderTarget.hpp"

namespace Dawn {
  class StandardRenderPipeline;

  class RenderManager : public IRenderManager {
    private:
      std::shared_ptr<StandardRenderPipeline> standardRenderPipeline;

    public:
      BackBufferRenderTarget backBuffer;

      /**
       * Construct a new RenderManager for a game instance.
       */
      RenderManager(DawnGame &game);
      RenderTarget & getBackBuffer() override;
      RenderPipeline & getRenderPipeline() override;
      void init() override;
      void update() override;
      
      /**
       * Destroy a previously initialized RenderManager.
       */
      ~RenderManager();
  };
}